' Macros fr ListView Bearbeitung. Version 4.0
' Eine Beschreibung der in den Funktionen benutzten Werten/Attributen befindet sich
' im Dokument LISTVIEW.TXT

' Autor: Gerhard Putschalka    
'                    homepage: http://members.telering.at/g.putschalka/index.html
'                       email: g.putschalka@web.de

' Um die Programme einfacher und bersichtlicher gestalten zu knnen werden hier
' einige Variablen mit fixen Namen verwendet.
' Sie werden hier global definiert.

' diese Declares werden hier global fr das Programm definiert. Sie sind namentlich fixiert.
Declare LV_Zeile&,LV_Hndl&,LV_ColMask&,LV_IList&,LV_AnzColumns%,LV_ITEM#,LV_Selected#

' Image-List Funktionen
Def @CreateImageList(5) !"comctl32.dll","ImageList_Create"
 ' @CreateImageList (xsize%,ysize%,farbtiefe%,imageAnzahl%,zusatz-platz-fr-x-images%)
Def @GetSystemMetrics(1) !"user32.dll","GetSystemMetrics"
 ' @GetSystemMetrics(MetricNumber) 'SM_CXSMICON : 49 SM_CYSMICON : 50
' Funktion um zu gucken, wie gro icons normalerweise vom user eingestellt sind
Def @SetImageList(3) sendmessage (@&(1),$1003,@%(3),@&(2))
 ' @SetImageList(Lv_handle$,Imagelist_handle&,ImageType%)
Def @DestroyImageList(1) !"comctl32.dll","ImageList_Destroy"
 ' @DestroyImageList (Ilisthandle&)

' Icon Funktionen
Def @LoadIcon(2) !"user32.dll","LoadIconA"
'@LoadIcon (%hinstance,string-pointer&) Im gepointeten bereich steht der IconName
'Rckgabewert ist das Handle des Icons
Def @AddIconToImageList(2) !"comctl32.dll","ImageList_AddIcon"
'@AddIconToImageList (listenhandle&,iconhandle&)
Def DestroyIcon(1) ! "USER32.DLL","DestroyIcon" ',"&","%"
'Parameter 1: ist das Handle des geladenen Icons

' ListView Funktionen
Def @GetSelectedCount(1) @sendmessage (@&(1),4146,0,0)
   '@GetSelectedCount(listenhandle&) ' Ergebnis: Anzahl markierter Zeilen

Def @GetItemCount(1) @sendmessage (@&(1),4100,0,0)
   '@GetItemCount(listenhandle&) ' Ergebnis: Anzahl Zeilen (Items in der Liste)

Def @GetItemText(3) @Sendmessage (@&(1),$102D,@&(2),@&(3))
   ' @GetItemText(Listenhandle&,Zeile&,Lv_Struktur) Ergebnis: Lnge des gefundenen Textes.
   ' der Text der Spalte der Zeile wird in LV_Item#,36 bertragen (die Spalte mu zuvor
   ' in LV_Item#,8 gesetzt worden sein).

Def @DeleteColumn(2) @sendmessage (@&(1),$101C,@%(2),0)
   '@DeleteColumn (listenhandle&,spaltenindex%) ' Ergebnis True (1) oder False (0)
   'Lscht eine ListViewSpalte

Def @DeleteItem(2) @sendmessage (@&(1),$1008,@%(2),0)
   '@DeleteItem (listenhandle&,zeilenindex%)
   'Lscht eine Zeile (Item) ' Ergebnis True (1) oder False (0)

Def @DelteAllItems(1) @sendmessage (@&(1),4105,0,0)
   '@DelteAllItems(listenhandle&) Lscht alle Items der Liste ' Ergebnis: True oder False
   ' ACHTUNG: die Variable LV_Zeile& mu auch auf Null gesetzt werde !!!

Def @GetItemState(3) @sendmessage (@&(1),4140,@%(2),@%(3))
   ' @GetItemState(listenhandle&,itemIndex%,status%)
   ' Ermittelt ob Item Nummer x(itemIndex%) den Status y(status%) hat
   ' status% kann folgende Werte haben:
   ' LVIS_FOCUSED   =   1, Das Item hat den Focus (kleines gepunktetes Rechteck um das Item)
   ' LVIS_SELECTED  =   2, Das Item ist ausgewhlt (in der Regel grauer Balken)
   ' LVIS_CUT       =   4, Das Item ist fr eine Asuschneiden / Einfgen OPertation markiert
   ' LVIS_DROPHILITED = 8, Item fr Drag'nDrop Operation markiert (in der Regel blauer Balken)   

'Verndern der Breite einer Spalte:
Def @SetColumnWidth(3) @sendmessage (@&(1),4126,@%(2),@%(3))
 ' @SetColumnWidth(Lvc_handle&,Spaltenindex%,Pixelbreite%)
 ' statt Pixelbreite knnen auch folgende Werte eingesetzt werden:
 ' LVSCW_AUTOSIZE  = -1 und LVSCW_AUTOSIZE_USEHEADER = -2
 ' bei -1 wird die Spalte so breit gemacht, dass der lngste Texteintrag in die Spalte passt,
 ' bei -2 wird die Spalte so breit gemacht, dass die Spaltenberschrift ind die Spalte passt.

'Die Listview Farbbefehle !
Def @GetLVTxtcolor(1) @sendmessage (@&(1),$1023,0,0)   ' Textfarbe
Def @GetLVTxtbkcolor(1) @sendmessage (@&(1),$1025,0,0) ' Texthintergrundfarbe
Def @GetLVbkcolor(1) @sendmessage (@&(1),$1000,0,0)    ' Fensterhintergrund

Def @SetLVTxtcolor(2) @sendmessage (@&(1),$1024,0,@&(2))   ' Textfarbe
Def @SetLVTxtbkcolor(2) @sendmessage (@&(1),$1026,0,@&(2)) ' Texthintergrundfarbe
Def @SetLVbkcolor(2) @sendmessage (@&(1),$1001,0,@&(2))    ' Fensterhintergrund

' =============================
' ImageList und Icon Prozeduren
' =============================
'*******************
' Add_Icon_to_List *
'*******************
' lade Icon und fge es zur Imageliste hinzu.
' Parameter 1: String mit Iconname, Parameter 2: Handle zur Datei aus der das Icon zu
' laden ist, Parameter 3: Handle der Imagelist
Proc Add_Icon_to_List
   Parameters Name$,ListHandle&,Imaglist&
   Declare Hicon&
   String LV_Item#,0=Name$
   Let Hicon&=@LoadIcon(ListHandle&,LV_Item#) ' Handle des Icons
   @AddIconToImageList(Imaglist&,HIcon&)      ' Icon in Imagelist hinzufgen
   DestroyIcon(HIcon&)                        ' Handle lschen
   Return
EndProc

' =====================
' ListView Prozeduren
' =====================
'*****************
' CreateListView *
'*****************

Proc CreateListView
'  Parameters hwnd&,Dwstyle&,xpos%,ypos%,xsize%,ysize%,dwExStyle%,ExLvStyle%,celemnt%
   Clear LV_Item#
   let LV_Hndl& = @control("SysListView32","",@&(2),@%(3),@%(4),@%(5),@%(6),@&(1),@%(9),\
                  %hinstance,@%(7))
   ifnot @equ(@%(8),0)
      @sendmessage (LV_Hndl&,4150,0,@%(8))
   endif
   Let LV_Zeile& = 0
   Let LV_AnzColumns% = 0
   return
endproc

'**********************
'CreateListViewColumn *
'**********************
'---------------- Parameter Dokumentation -------------------------
' Handle&  : Parameter des ListViewControls, in das die Spalte soll
' Maske&   : Spaltenstiel siehe LV_COLUMN-Struc in Api-dokumentation
' Format&  : Schrift-ausrichtung 0:links 1:rechts 2:center
' Breite&  : Spaltenbreite in Pixel%
' Name$    : berschrift der Spalte
' Subitem& : Subspaltenindex, ist die Spalte. Die Erste = 0
Proc CreateListviewColumn
   Parameters Handle&,Maske&,Format&,Breite&,Name$,Subitem&
   Clear LV_Item#
   Long LV_Item#,0 = Maske&
   Long LV_Item#,4 = Format&
   Long LV_Item#,8 = Breite&
   Long LV_Item#,12 = @add(LV_Item#,24)
   Long LV_Item#,16 = 255
   Long LV_Item#,20 = Subitem&
   String LV_Item#,24 = Name$
   @Sendmessage (Handle&,$101B,Subitem&,LV_Item#) 'LVM_INSERTCOLUMNA
   Clear LV_Item#
   Inc LV_AnzColumns%
endproc

'*********************
' Add_Zeile          *
'*********************
' fgt eine Zeile im ListView ein. Der Text der Zeile kann aus mehreren Teilen bestehen
' (soviele Texte als Spalten im ListView eingefgt wurden - maximal 12).
' Prozedur fr Einfgung ohne Icon.
'---------------- Parameter Dokumentation -------------------------
' Add_Zeile Text_Spalte1,Text_Spalte2, .... 
' weitere erwartete Werte (in globalen Variablen):
' LV_Hndl&    = Handle des ListViewControls
' LV_ColMask& = Maske
' LV_Zeile&   = Nummer der einzufgenden Zeile. (Zhlung beginnt mit Null).
'               Um eine neue Zeile am Ende der Liste einzufgen mu der Wert -1 sein.  
'               Der Sinn von LV_Zeile& besteht darin, auch eine bereits existierende Zeilen-
'               nummer anzugeben. In diesem Fall wird diese Zeile an der Position in der
'               Liste eingefgt und alle folgenden Zeilen werden um eine Position verschoben.

' Rckgabewert: Zeilennummer die eingefgt wurde (mit Null beginnend). -1 wenn Fehler.
Proc Add_Zeile
' in den Parametern 1 bis max. 12 werden die Texte der Spalten bergeben.
   Declare NewItemIndex&,Count%,Line&
   If (LV_Zeile& < 0) 
      Line& = (@Sendmessage (LV_Hndl&,$1004,0,0) +1)
   Else
      Line& = LV_Zeile&
   EndIf

   Let Count% = 0
   clear LV_ITEM#
   Long LV_ITEM#,0 = LV_ColMask&
   Long LV_ITEM#,4 = Line&
   Long LV_ITEM#,8 = Count%
   Long LV_ITEM#,12 = 0
   Long LV_ITEM#,16 = 0
   Long LV_ITEM#,20 = @add(LV_ITEM#,36)
   Long LV_ITEM#,24 = 255
   Long LV_ITEM#,28 = 0
   Long LV_ITEM#,32 = 0
   Inc Count%
   String LV_ITEM#,36 = @$(Count%)
   Let NewItemIndex& = @Sendmessage (LV_Hndl&,$1007,0,LV_ITEM#) 'LVM_INSERTITEM
   WhileNot (Count% > %PCount)
      Long LV_ITEM#,8 = Count%
      Inc Count%
      String LV_ITEM#,36 = @$(Count%)
      @Sendmessage(LV_Hndl&,$102E,NewItemIndex&,LV_ITEM#) '--LVM_SETITEMTEXT
   EndWhile
   Return NewItemIndex&
endproc

'***********************
' Add_Zeile_I          *
'***********************
' Variante von Add_Zeile mit der auch ein Icon zugeordnet wird.
' fgt eine Zeile im ListView ein. Der Text der Zeile kann aus mehreren Teilen bestehen
' (soviele Texte als Spalten im ListView eingefgt wurden maximal 11).
' als letzter Parameter ist die Iconnummer anzugeben. Die Position des Parameters ist
' Anzahl Spalten + 1 (also nicht fix Parameter 12).
'---------------- Parameter Dokumentation -------------------------
' Add_Zeile_I Text_Spalte1,Text_Spalte2, .... letzter Parameter ist die Iconnummer
' weitere erwartete Werte (in globalen Variablen):
' LV_Hndl&    = Handle des ListViewControls
' LV_ColMask& = Maske
' LV_Zeile&   = Nummer der einzufgenden Zeile. (Zhlung beginnt mit Null).
'               Um eine neue Zeile am Ende der Liste einzufgen mu der Wert -1 sein.  
'               Der Sinn von LV_Zeile& besteht darin, auch eine bereits existierende Zeilen-
'               nummer anzugeben. In diesem Fall wird diese Zeile an der Position in der
'               Liste eingefgt und alle folgenden Zeilen werden um eine Position verschoben.

' Rckgabewert: Zeilennummer die eingefgt wurde (mit Null beginnend). -1 wenn Fehler.
Proc Add_Zeile_I
   ' in den Parametern 1 bis max. 11 werden die Texte der Spalten bergeben.
   ' hinter dem letzten bergebenen Spaltentext folgt die Nummer des anzuzeigenden Icons
   Declare NewItemIndex&,Count%,Line&
   If (LV_Zeile& < 0) 
      Line& = (@Sendmessage (LV_Hndl&,$1004,0,0) +1)
   Else
      Line& = LV_Zeile&
   EndIf

   Let Count% = 0
   clear LV_ITEM#
   Long LV_ITEM#,0 = LV_ColMask&
   Long LV_ITEM#,4 = Line&
   Long LV_ITEM#,8 = Count%
   Long LV_ITEM#,12 = 0
   Long LV_ITEM#,16 = 0
   Long LV_ITEM#,20 = @add(LV_ITEM#,36)
   Long LV_ITEM#,24 = 255
   Long LV_ITEM#,28 = @&(%Pcount)
   Long LV_ITEM#,32 = 0
   Inc Count%
   String LV_ITEM#,36 = @$(Count%)
   Let NewItemIndex& = sendmessage (LV_Hndl&,$1007,0,LV_ITEM#) 'LVM_INSERTITEM
   Long LV_ITEM#,28 = 0
   While (Count% < %PCount)
      Long LV_ITEM#,8 = Count%
      Inc Count%
      String LV_ITEM#,36 = @$(Count%)
      @Sendmessage(LV_Hndl&,4142,NewItemIndex&,LV_ITEM#) '--LVM_SETITEMTEXT
   EndWhile
   Return NewItemIndex&
endproc

'***********************
' GetSelectedItems     *
'***********************
' setze die Adressen der markierten Zeilen als Words(!) in LV_Selected#
Proc GetSelectedItems
   Parameters Startitem%
   ' StartItem gibt an, mit welcher Zeile begonnen wird
   Declare Selected_Count%,I%
   WhileNot @equ(Selected_Count%,@GetSelectedCount(LV_Hndl&))
      If @equ(@Sendmessage(LV_Hndl&,$102C,i%,2),2)
         Word LV_Selected#,@mul(Selected_Count%,2) = @add(Startitem%,I%)
         Inc Selected_Count%
      Endif
      Inc i%
   EndWhile
   Return @GetSelectedCount (LV_Hndl&)
EndProc

'***********************
' Hole_Zeile           *
'***********************
' liest alle Spalten einer Zeile und setzt sie, durch ein Tabulatorbyte (@Chr$(9)
' getrennt, zusammen.
' Parameter: Nummer der Zeile (Zeile1 ist Null)
' Rckgabewert: die zusammengesetzte Zeile
Proc Hole_Zeile
   Parameters Element%  ' Index zu Lv_Selected#
   Declare Fld$,X1%,Zl&
   ' da die "Elemente" in Lv_Selected# aus WORDs (2-Bytes) bestehen mu der "Index"
   ' verdoppelt werden:
   Let Element% = (Element% + Element%)
   Let Zl& = @Word(Lv_Selected#,Element%) ' hole Zeilennummer die markiert wurde
   ' alle Spalten der Zeile auslesen und zusammenfgen
   Let X1% = 0
   Let Fld$ = ""
   ' auslesen und zusammenfgen der Texte der einzelnen Spalten
   While (X1% < LV_AnzColumns%) ' Anzahl Spalten
      Long LV_Item#,8 = X1%    ' Spalte
      Long LV_Item#,36 = 0     ' auf 0 setzen, falls die Spalte keinen Text enthlt
      @GetItemText(LV_Hndl&,Zl&,LV_Item#) ' hole text in Lv_Liste#,36
      Let Fld$ = Fld$;@string$(LV_Item#,36);"\t"
      Inc X1%
   EndWhile
   ' die bergabe erfolgt in einer Stringvariablen, welche vor Profan 7 auf 255 Stellen
   ' beschrnkt ist. Dies sollte aber bei einer "Listbox" ausreichen.
   Return Fld$
EndProc
' ========== Ende Makros =================
